<?
/*
*******************************
 IP-SYMCON V2 Event Scripting
*******************************
File     : AVR_NET_IO_Uebernahme
Trigger  : AVR-NET-IO_Register Variable / Zustandsvariablen der Ausgnge
Interval : direkter Aufruf durch die Variablen bzw. Registervariable
Autor    : EHB
*/

// ID der Registervariablen (Parent-ID)
$RegVar_ID = 14853;

include(IPS_GetScriptIDByName("AVR-NET-IO_Include",$RegVar_ID).".ips.php"); // Grundeinstellungen und Funktionen einbinden

// Prfen, ob Ausgangsvariablen angelegt sind, wenn Nein --> anlegen ***********
for ($i = 0; $i < 9; $i++)
{
	if(IPS_GetVariableIDByName($Ausgang[$i],$RegVar_ID) == 0)  // Variable nicht vorhanden
  	{
  		$Variable_ID = IPS_CreateVariable(0); // Variable vom Typ "Boolean" erzeugen
  	 	IPS_SetName($Variable_ID,$Ausgang[$i]); // Der neu generierten ID einen Namen zuweisen
   	IPS_SetParent($Variable_ID,$RegVar_ID); // Variable der Registervariablen des AVR zuordnen
   	$Event_ID = IPS_CreateEvent(0); // "Ausgelstes Ereignis" anlegen
		if ($i <= 7)
		{
			IPS_SetEventTrigger($Event_ID, 1,$Variable_ID); // Bei nderung von Variable ....
      	IPS_SetEventScript($Event_ID, $IPS_SELF); // Das aktuelle Script ausfhren
      	IPS_SetEventActive($Event_ID, true); // Event aktivieren
		}
	}
}

// Script durch Variable getriggert --> Ausgang schalten ***********************
if ($IPS_SENDER == "Variable")
{
	// Informationen ber die Variable bernehmen, die das Script getriggert hat
	$VarInfo = IPS_GetObject($IPS_VARIABLE); // Object - Infos
	$VarName = $VarInfo[ObjectName]; // Variablen-Name
	$VarWert = $IPS_VALUE; // Wert der Variablen bernehmen
	// Portnummer des Ausgangs ermitteln
	for ($i = 0; $i < 8; $i++)
	{
		if ($Ausgang[$i] == $VarName) // Name der Variable, die das Script getriggert hat
		{
			$Portnummer = $i;
			$i = 8;
		}
	}
	$Befehl = 26 - $IPS_VALUE; // 25 = Setzen, 26 = Rcksetzen Port; True = 1, False = 0
   $String = "02 ".$Befehl." ".$Portnummer." 03\r\n"; // Schaltbefehl zusammenstellen
   Befehl_senden($CS_ID,$Var_ID_NETIO_OK,$String); // Schaltbefehl senden
}

// Script durch Registervariable getriggert --> Meldung von AVR-NET-IO *********
if ($IPS_SENDER == "RegisterVariable")
{
	$Frame = $IPS_VALUE; // Daten von Registervariable bernehmen
	$Parameter = explode(' ',$Frame); // String in einzeln Werte zerlegen
   $Befehl = $Parameter[0];          // Befehl bernehmen
   if ($Befehl == chr(06))          // ASCII-Code ersetzen
      $Befehl = "06";
	if ($Befehl == chr(21))           // ASCII-Code ersetzen
	   $Befehl = "15";
  
	IPS_LogMessage("Befehl : ",$Befehl);

	switch((int)$Befehl) // Befehl auswerten, Aktoren ansteuern **********************
		{
			case 00: // "Keepalive" Meldung vom Modul - Script-Timer Keep_alive-Script auf 65 Sekunden setzen
			   IPS_SetScriptTimer(21157,65);
				SetValue($Var_ID_NETIO_OK, true);
				IPS_LogMessage("Keepalive-Meldung ","empfangen");
			   return; // Script beenden
      	break;
			case 03: // Telnetserver wurde neu gestartet --> Zustnde aktualisieren
				IPS_RunScript(IPS_GetScriptID("AVR-NET-IO_Abgleich"));
				IPS_LogMessage("Modul wurde neu gestartet ","Datenbabgleich gestartet");
				return; // Script beenden
			break;
   		case 06: // "ACK" empfangen - positive Besttigung
				SetValue($Var_ID_NETIO_OK, true);
				IPS_LogMessage("bertragung war ","OK");
				return; // Script beenden
			break;
   		case 10: // Zustnde aller digitalen Eingnge empfangen

			break;
   		case 11: // Zustnde eines digitalen Eingangs empfangen

			break;
	   	case 15: // "NAK" empfangen - negative Besttigung
	   	   $Var_ID = IPS_GetVariableIDByName($Ausgang[8],$RegVar_ID); // ID der Zusatndsvariable ermitteln
				SetValue($Var_ID, false);
				IPS_LogMessage("bertragung war ","nicht OK");
				return; // Script beenden
			break;
   		case 20: // Zustnde aller digitalen Ausgnge empfangen

			break;
   		case 21: // Zustnde eines digitalen Ausgangs empfangen

			break;
   		case 25: // Digitalen Ausgang einschalten

			break;
   		case 26: // Digitalen Ausgang ausschalten

			break;
   		case 27: // Digitale Ausgnge einschalten

			break;
   		case 28: // Digitale Ausgnge ausschalten

			break;
   		case 30: // Messwert eines anloges Ausgangs empfangen

			break;
		}


	$Port = (int) $Parameter[1]; 		// Portnummer bernehmen
   $Zustand = (int) $Parameter[2];  // Messwert / Zustand des Ports bernehmen

   // berprfen, ob Variable vorhanden, wenn NEIN --> anlegen
	if(IPS_GetVariableIDByName($PortName[$Port],$RegVar_ID) == 0)  // Variable nicht vorhanden
  	{
  	   if ($Port <= 3) // Port-Nummer 0 ... 3
  	   {
  			$Variable_ID = IPS_CreateVariable(0); // Variable vom Typ "Boolean" erzeugen
	 	}
	 	else           // Port-Nummer > 3
	 	{
	 	   $Variable_ID = IPS_CreateVariable(1); // Variable vom Typ "Integer" erzeugen
		}
  	 	IPS_SetName($Variable_ID,$PortName[$Port]); // Der neu generierten ID einen Namen zuweisen
   	IPS_SetParent($Variable_ID,$RegVar_ID); // Variable der Registervariable zuordnen
	}

	// Weitergeben der empfangenen Daten an die Zustandsvariablen der Eingnge
   $Variable_ID = IPS_GetVariableIDByName($PortName[$Port],$RegVar_ID); // ID ermitteln
	SetValue($Variable_ID,$Zustand); // Zustand bergeben
}
?>